
{ Recherche d'anagrammes dans une liste de mots franais.
  Compilation Free Pascal 2.6, Virtual Pascal 2.1. }

program Anagrammes;

{$IFDEF FPC}
{$APPTYPE CONSOLE}
{$MODE DELPHI}
uses
  Crt;
{$ENDIF}

{$IFDEF VPASCAL}
{&PMTYPE VIO}
uses
  Crt, SysUtils;
{$ENDIF}

{$R Icone.res}

type
  tMot = record
           n: integer; // nombre de lettres
           lettres: array['a'..'z'] of byte;
         end;

function fSansAccentsNiMajuscules(const cS: string): string;
var i: integer;
begin
  result := LowerCase(cS);
  for i := 1 to Length(result) do
    case result[i] of
      '','','': result[i] := 'a';
      '','','','': result[i] := 'e';
      '','': result[i] := 'i';
      '','': result[i] := 'o';
      '','','': result[i] := 'u';
      '': result[i] := 'c';
    end;
end;

function fMot(const cS: string): tMot;
var
  c: char;
  i: integer;
  lS: string;
  TU: integer;
begin
  lS := fSansAccentsNiMajuscules(cS);
  result.n := Length(lS);
  for c := 'a' to 'z' do result.lettres[c] := 0;
  TU := 0;
  for i := 1 to result.n do
    if lS[i] = '-' then
      Inc(TU)
    else
      Inc(result.lettres[lS[i]]);
  Dec(result.n, TU);
end;

var
  f: text;
  s1, s2: string;
  m1, m2: tMot;
  c: char;
  anagramme: boolean;
  compte: integer;
  touche: char;

label
  DEBUT;

begin
  TextBackground(Blue);
  TextColor(White);

  DEBUT:

  ClrScr;

  Write(#10'--- Anagrammes -----------------------------------------------------------------'#10#10);
  Write('Tapez un mot pour connatre ses anagrammes.'#13#10#10);
  Write('Votre mot : ');
  TextBackground(Green);
  ReadLn(s1);
  TextBackground(Blue);
  WriteLn;

  m1 := fMot(s1);

  Assign(f, 'Mots.txt');
  Reset(f);

  compte := 0;

  while not EOF(f) do
  begin
    ReadLn(f, s2);
    m2 := fMot(s2);

    if m2.n = m1.n then
    begin
      anagramme := true;

      for c := 'a' to 'z' do
        if m2.lettres[c] <> m1.lettres[c] then
        begin
          anagramme := false;
          Break;
        end;

      if anagramme then
      begin
        Inc(compte);
        WriteLn(compte:2, '. ', s2);
      end;
    end;

  end;

  Close(f);

  WriteLn(#10'Fin de la recherche.'#10);
  Write('Nouvelle recherche [o/n] ? ');

  touche := ReadKey;

  if (touche = 'o') or (touche = 'O') then
    goto DEBUT;
end.
